SystemOrganization addCategory: #RoassalScroller!

Object subclass: #AbstractScrollBar
	instanceVariableNames: 'barWidth barHeight container scrollBar roMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalScroller'!

!AbstractScrollBar methodsFor: 'accessing' stamp: 'ub 9/22/2012 21:54'!
barHeight
	^ barHeight! !

!AbstractScrollBar methodsFor: 'accessing' stamp: 'ub 9/22/2012 21:54'!
barHeight: anObject
	barHeight := anObject! !

!AbstractScrollBar methodsFor: 'accessing' stamp: 'ub 9/22/2012 21:55'!
barWidth
	^ barWidth! !

!AbstractScrollBar methodsFor: 'accessing' stamp: 'ub 9/22/2012 21:55'!
barWidth: anObject
	barWidth := anObject! !

!AbstractScrollBar methodsFor: 'accessing' stamp: 'ub 9/22/2012 21:52'!
container
	^ container! !

!AbstractScrollBar methodsFor: 'accessing' stamp: 'ub 9/22/2012 21:52'!
container: anObject
	container := anObject! !

!AbstractScrollBar methodsFor: 'container' stamp: 'ub 9/22/2012 23:06'!
containerElement

	container := ROElement new 
		width: self containerWidth; 
		height: self containerHeight; 
		yourself.
	container + (ROBox new color: Color blue).
	self hightlightChildrenOf: container.! !

!AbstractScrollBar methodsFor: 'container' stamp: 'ub 9/22/2012 22:14'!
containerHeight
	self subclassResponsibility! !

!AbstractScrollBar methodsFor: 'container' stamp: 'ub 9/22/2012 22:14'!
containerWidth
	self subclassResponsibility! !

!AbstractScrollBar methodsFor: 'initialization' stamp: 'ub 9/22/2012 22:34'!
createBarWIth: aView
	roMorph := ROMorph on: aView.
	self containerElement.
	self scrollBarElement.
	container add: scrollBar.
	container translateBy: (roMorph extent x - 50)@ 0.
	scrollBar translateBy: 40@0.
! !

!AbstractScrollBar methodsFor: 'highlight' stamp: 'ub 9/22/2012 21:53'!
hightlightChildrenOf: anObject
	anObject on: ROMouseEnter do: [:event | 
			event element elementsDo: [:each | ROHighlightElement on: (each) color: Color lightGray lighter] ].
	anObject on: ROMouseLeave do: [:event |  
		event element elementsDo: [:each | ROUnhighlightElement on: (each)]]. ! !

!AbstractScrollBar methodsFor: 'highlight' stamp: 'ub 9/22/2012 21:53'!
hightlightOn: anObject
	anObject on: ROMouseEnter do: [:event | 
			ROHighlightElement on: (event element) color: Color lightGray lighter ].
	anObject on: ROMouseLeave do: [:event |  
		ROUnhighlightElement on: (event element)].! !

!AbstractScrollBar methodsFor: 'accessing' stamp: 'ub 9/22/2012 21:52'!
scrollBar
	^ scrollBar! !

!AbstractScrollBar methodsFor: 'accessing' stamp: 'ub 9/22/2012 21:52'!
scrollBar: anObject
	scrollBar := anObject! !

!AbstractScrollBar methodsFor: 'scrollbar' stamp: 'ub 9/22/2012 22:44'!
scrollBarDragBehaviorOn: aStack
	self subclassResponsibility.! !

!AbstractScrollBar methodsFor: 'scrollbar' stamp: 'ub 9/22/2012 22:29'!
scrollBarElement
	scrollBar :=  ROElement new
					width: self barWidth;
					height: self barHeight; 
					yourself.
					
	scrollBar + self scrollBarShape.
	self hightlightOn: scrollBar.
		! !

!AbstractScrollBar methodsFor: 'scrollbar' stamp: 'ub 9/22/2012 21:56'!
scrollBarShape
	^  (ROBox new color: Color transparent)! !

!AbstractScrollBar methodsFor: 'scrollbar' stamp: 'ub 9/22/2012 22:56'!
scrollbarFor: aStack

	| view |
	view := aStack firstView.
	self createBarWIth: view.
	self scrollBarDragBehaviorOn: aStack.
	^ self container! !

AbstractScrollBar subclass: #HorizontalScrollBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalScroller'!

!HorizontalScrollBar methodsFor: 'container' stamp: 'ub 9/22/2012 22:58'!
containerHeight 
	^ self barHeight * 5! !

!HorizontalScrollBar methodsFor: 'container' stamp: 'ub 9/22/2012 22:51'!
containerWidth 
	^ roMorph extent x! !

!HorizontalScrollBar methodsFor: 'scrollbar' stamp: 'ub 9/22/2012 23:01'!
createBarWIth: aView
	roMorph := ROMorph on: aView.
	self containerElement.
	self scrollBarElement.
	container add: scrollBar.
	container translateBy: 0@(roMorph extent y - 50).
	scrollBar translateBy: 0@40.
! !

!HorizontalScrollBar methodsFor: 'initialize-release' stamp: 'ub 9/22/2012 21:56'!
initialize 
	self barWidth: 60.
	self barHeight: 10.! !

!HorizontalScrollBar methodsFor: 'scrollbar' stamp: 'ub 9/22/2012 23:03'!
scrollBarDragBehaviorOn: aStack
	| view |
	view := aStack firstView.
		scrollBar on: ROMouseDragging do: [ :event | 
		scrollBar translateByRealPoint: (event step * (1@0)).
		scrollBar translateTo: (scrollBar position max: 0@0).
		scrollBar translateTo: (scrollBar position min: (aStack camera width - scrollBar width) @ 0).
		scrollBar translateBy: 0@40.
		(scrollBar position x >= 0 and: [ scrollBar position x  <=  (aStack camera extent x - scrollBar width)])
			ifTrue: [ 
				| xView |
				xView := view encompassingRectangle width * scrollBar position x / view camera width negated.
				view translateTo: (xView @ view camera position y negated) asIntegerPoint ].
		scrollBar signalUpdate.
	].
! !

AbstractScrollBar subclass: #VerticalScrollBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalScroller'!

!VerticalScrollBar methodsFor: 'container' stamp: 'ub 9/22/2012 22:50'!
containerHeight 
	^ roMorph extent y! !

!VerticalScrollBar methodsFor: 'container' stamp: 'ub 9/22/2012 22:50'!
containerWidth 
	^ self barWidth * 5! !

!VerticalScrollBar methodsFor: 'initialize-release' stamp: 'ub 9/22/2012 22:44'!
initialize 
	self barWidth: 10.
	self barHeight: 60.! !

!VerticalScrollBar methodsFor: 'scrollbar' stamp: 'ub 9/22/2012 22:40'!
scrollBarDragBehaviorOn: aStack
	| view |
	view := aStack firstView.
	scrollBar on: ROMouseDragging do: [ :event | 

		scrollBar translateByRealPoint: (event step * (0@1)).
		scrollBar translateTo: (scrollBar position max: 0@0).
		scrollBar translateTo: (scrollBar position min: 0 @ (aStack camera extent y - scrollBar height)).
		scrollBar translateBy: 40@0.
		(scrollBar position y >= 0 and: [ scrollBar position y  <=  (aStack camera extent y  - scrollBar height)])
			ifTrue: [ 
				| yView |
				yView := view encompassingRectangle height * scrollBar position y / view camera extent y  negated.
				view translateTo: (view camera position x negated @ yView) asIntegerPoint ].
		scrollBar signalUpdate.
	].

	view on: ROMouseDragging do: [ :event | 
		scrollBar translateBy: (event step negated * (0 @ 1)).
		scrollBar translateTo: (scrollBar position max: 0@0).
		scrollBar translateTo: (scrollBar position min: 0 @ aStack camera extent y - scrollBar height).
	].! !

ROScrollbable subclass: #RoassalScrollbable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalScroller'!

!RoassalScrollbable methodsFor: 'hooks' stamp: 'ub 9/22/2012 22:54'!
horizontalScrollbarFor: aStack

	^ HorizontalScrollBar new scrollbarFor: aStack.! !

!RoassalScrollbable methodsFor: 'hooks' stamp: 'ub 9/22/2012 22:54'!
verticalScrollbarFor: aStack

	^ VerticalScrollBar new scrollbarFor: aStack.! !
